commit cb6abe7283fd973e5dacbbf7a8bc920fd2eed089
Author: Miltiadis Vasilakis <mvasilak@gmail.com>
Date:   Mon Jan 14 12:14:52 2013 +0200

    Convert to Objective-C ARC
    
    Use Xcode refactoring to convert project to Objective-C ARC, to fix problems that memory is freed more than once, when autorelease pools are drained. Update version.

diff --git a/pithos-macos.xcodeproj/project.pbxproj b/pithos-macos.xcodeproj/project.pbxproj
index 3ba0ad6..c3c1a3e 100644
--- a/pithos-macos.xcodeproj/project.pbxproj
+++ b/pithos-macos.xcodeproj/project.pbxproj
@@ -13,19 +13,19 @@
 		610DD30613E6BB2000ED982F /* Credits.rtf in Resources */ = {isa = PBXBuildFile; fileRef = 610DD30413E6BB2000ED982F /* Credits.rtf */; };
 		610DD30913E6BB2000ED982F /* pithos_macosAppDelegate.m in Sources */ = {isa = PBXBuildFile; fileRef = 610DD30813E6BB2000ED982F /* pithos_macosAppDelegate.m */; };
 		610DD30C13E6BB2000ED982F /* MainMenu.xib in Resources */ = {isa = PBXBuildFile; fileRef = 610DD30A13E6BB2000ED982F /* MainMenu.xib */; };
-		610DD33E13E6BD8B00ED982F /* ASIDataCompressor.m in Sources */ = {isa = PBXBuildFile; fileRef = 610DD32013E6BD8B00ED982F /* ASIDataCompressor.m */; };
-		610DD33F13E6BD8B00ED982F /* ASIDataDecompressor.m in Sources */ = {isa = PBXBuildFile; fileRef = 610DD32213E6BD8B00ED982F /* ASIDataDecompressor.m */; };
-		610DD34013E6BD8B00ED982F /* ASIDownloadCache.m in Sources */ = {isa = PBXBuildFile; fileRef = 610DD32413E6BD8B00ED982F /* ASIDownloadCache.m */; };
-		610DD34113E6BD8B00ED982F /* ASIFormDataRequest.m in Sources */ = {isa = PBXBuildFile; fileRef = 610DD32613E6BD8B00ED982F /* ASIFormDataRequest.m */; };
-		610DD34213E6BD8B00ED982F /* ASIHTTPRequest.m in Sources */ = {isa = PBXBuildFile; fileRef = 610DD32813E6BD8B00ED982F /* ASIHTTPRequest.m */; };
-		610DD34313E6BD8B00ED982F /* ASIInputStream.m in Sources */ = {isa = PBXBuildFile; fileRef = 610DD32C13E6BD8B00ED982F /* ASIInputStream.m */; };
-		610DD34413E6BD8B00ED982F /* ASINetworkQueue.m in Sources */ = {isa = PBXBuildFile; fileRef = 610DD32E13E6BD8B00ED982F /* ASINetworkQueue.m */; };
-		610DD34513E6BD8B00ED982F /* ASIPithosAccountRequest.m in Sources */ = {isa = PBXBuildFile; fileRef = 610DD33213E6BD8B00ED982F /* ASIPithosAccountRequest.m */; };
-		610DD34613E6BD8B00ED982F /* ASIPithosContainer.m in Sources */ = {isa = PBXBuildFile; fileRef = 610DD33413E6BD8B00ED982F /* ASIPithosContainer.m */; };
-		610DD34713E6BD8B00ED982F /* ASIPithosContainerRequest.m in Sources */ = {isa = PBXBuildFile; fileRef = 610DD33613E6BD8B00ED982F /* ASIPithosContainerRequest.m */; };
-		610DD34813E6BD8B00ED982F /* ASIPithosObject.m in Sources */ = {isa = PBXBuildFile; fileRef = 610DD33813E6BD8B00ED982F /* ASIPithosObject.m */; };
-		610DD34913E6BD8B00ED982F /* ASIPithosObjectRequest.m in Sources */ = {isa = PBXBuildFile; fileRef = 610DD33A13E6BD8B00ED982F /* ASIPithosObjectRequest.m */; };
-		610DD34A13E6BD8B00ED982F /* ASIPithosRequest.m in Sources */ = {isa = PBXBuildFile; fileRef = 610DD33C13E6BD8B00ED982F /* ASIPithosRequest.m */; };
+		610DD33E13E6BD8B00ED982F /* ASIDataCompressor.m in Sources */ = {isa = PBXBuildFile; fileRef = 610DD32013E6BD8B00ED982F /* ASIDataCompressor.m */; settings = {COMPILER_FLAGS = "-fno-objc-arc"; }; };
+		610DD33F13E6BD8B00ED982F /* ASIDataDecompressor.m in Sources */ = {isa = PBXBuildFile; fileRef = 610DD32213E6BD8B00ED982F /* ASIDataDecompressor.m */; settings = {COMPILER_FLAGS = "-fno-objc-arc"; }; };
+		610DD34013E6BD8B00ED982F /* ASIDownloadCache.m in Sources */ = {isa = PBXBuildFile; fileRef = 610DD32413E6BD8B00ED982F /* ASIDownloadCache.m */; settings = {COMPILER_FLAGS = "-fno-objc-arc"; }; };
+		610DD34113E6BD8B00ED982F /* ASIFormDataRequest.m in Sources */ = {isa = PBXBuildFile; fileRef = 610DD32613E6BD8B00ED982F /* ASIFormDataRequest.m */; settings = {COMPILER_FLAGS = "-fno-objc-arc"; }; };
+		610DD34213E6BD8B00ED982F /* ASIHTTPRequest.m in Sources */ = {isa = PBXBuildFile; fileRef = 610DD32813E6BD8B00ED982F /* ASIHTTPRequest.m */; settings = {COMPILER_FLAGS = "-fno-objc-arc"; }; };
+		610DD34313E6BD8B00ED982F /* ASIInputStream.m in Sources */ = {isa = PBXBuildFile; fileRef = 610DD32C13E6BD8B00ED982F /* ASIInputStream.m */; settings = {COMPILER_FLAGS = "-fno-objc-arc"; }; };
+		610DD34413E6BD8B00ED982F /* ASINetworkQueue.m in Sources */ = {isa = PBXBuildFile; fileRef = 610DD32E13E6BD8B00ED982F /* ASINetworkQueue.m */; settings = {COMPILER_FLAGS = "-fno-objc-arc"; }; };
+		610DD34513E6BD8B00ED982F /* ASIPithosAccountRequest.m in Sources */ = {isa = PBXBuildFile; fileRef = 610DD33213E6BD8B00ED982F /* ASIPithosAccountRequest.m */; settings = {COMPILER_FLAGS = "-fno-objc-arc"; }; };
+		610DD34613E6BD8B00ED982F /* ASIPithosContainer.m in Sources */ = {isa = PBXBuildFile; fileRef = 610DD33413E6BD8B00ED982F /* ASIPithosContainer.m */; settings = {COMPILER_FLAGS = "-fno-objc-arc"; }; };
+		610DD34713E6BD8B00ED982F /* ASIPithosContainerRequest.m in Sources */ = {isa = PBXBuildFile; fileRef = 610DD33613E6BD8B00ED982F /* ASIPithosContainerRequest.m */; settings = {COMPILER_FLAGS = "-fno-objc-arc"; }; };
+		610DD34813E6BD8B00ED982F /* ASIPithosObject.m in Sources */ = {isa = PBXBuildFile; fileRef = 610DD33813E6BD8B00ED982F /* ASIPithosObject.m */; settings = {COMPILER_FLAGS = "-fno-objc-arc"; }; };
+		610DD34913E6BD8B00ED982F /* ASIPithosObjectRequest.m in Sources */ = {isa = PBXBuildFile; fileRef = 610DD33A13E6BD8B00ED982F /* ASIPithosObjectRequest.m */; settings = {COMPILER_FLAGS = "-fno-objc-arc"; }; };
+		610DD34A13E6BD8B00ED982F /* ASIPithosRequest.m in Sources */ = {isa = PBXBuildFile; fileRef = 610DD33C13E6BD8B00ED982F /* ASIPithosRequest.m */; settings = {COMPILER_FLAGS = "-fno-objc-arc"; }; };
 		610DD34E13E6BEF400ED982F /* PithosBrowserController.m in Sources */ = {isa = PBXBuildFile; fileRef = 610DD34D13E6BEF400ED982F /* PithosBrowserController.m */; };
 		610DD35013E6C00E00ED982F /* PithosBrowserController.xib in Resources */ = {isa = PBXBuildFile; fileRef = 610DD34F13E6C00E00ED982F /* PithosBrowserController.xib */; };
 		610DD35413E6C09100ED982F /* CoreServices.framework in Frameworks */ = {isa = PBXBuildFile; fileRef = 610DD35313E6C09100ED982F /* CoreServices.framework */; };
@@ -44,9 +44,9 @@
 		613629B9143E51E000363787 /* GroupAndGroupMemberFormatter.m in Sources */ = {isa = PBXBuildFile; fileRef = 613629B8143E51E000363787 /* GroupAndGroupMemberFormatter.m */; };
 		6139837113EFEECC004CE444 /* FileSystemBrowserCell.m in Sources */ = {isa = PBXBuildFile; fileRef = 6139837013EFEECC004CE444 /* FileSystemBrowserCell.m */; };
 		613BA8631461520E00FACAA5 /* NonEmptyStringFormatter.m in Sources */ = {isa = PBXBuildFile; fileRef = 613BA8621461520E00FACAA5 /* NonEmptyStringFormatter.m */; };
-		614299A914CEF0E7008D973A /* ASIPithos.m in Sources */ = {isa = PBXBuildFile; fileRef = 614299A814CEF0E7008D973A /* ASIPithos.m */; };
+		614299A914CEF0E7008D973A /* ASIPithos.m in Sources */ = {isa = PBXBuildFile; fileRef = 614299A814CEF0E7008D973A /* ASIPithos.m */; settings = {COMPILER_FLAGS = "-fno-objc-arc"; }; };
 		61433BC9141BA1CE00CD978D /* HashMapHash.m in Sources */ = {isa = PBXBuildFile; fileRef = 61433BC8141BA1CE00CD978D /* HashMapHash.m */; };
-		614592BC1417CE70002E7A8C /* ASIPithosAccount.m in Sources */ = {isa = PBXBuildFile; fileRef = 614592BB1417CE70002E7A8C /* ASIPithosAccount.m */; };
+		614592BC1417CE70002E7A8C /* ASIPithosAccount.m in Sources */ = {isa = PBXBuildFile; fileRef = 614592BB1417CE70002E7A8C /* ASIPithosAccount.m */; settings = {COMPILER_FLAGS = "-fno-objc-arc"; }; };
 		614EEC8414E16EB5009DEFCC /* PithosAccount.m in Sources */ = {isa = PBXBuildFile; fileRef = 614EEC8314E16EB5009DEFCC /* PithosAccount.m */; };
 		6152D08C143200CC00803874 /* PithosSharingAccountsNode.m in Sources */ = {isa = PBXBuildFile; fileRef = 6152D08B143200CC00803874 /* PithosSharingAccountsNode.m */; };
 		6152D092143334CC00803874 /* AllowedToBoolTransformer.m in Sources */ = {isa = PBXBuildFile; fileRef = 6152D091143334CC00803874 /* AllowedToBoolTransformer.m */; };
@@ -79,12 +79,12 @@
 		61F040F31448547000A0C788 /* FileMD5Hash.c in Sources */ = {isa = PBXBuildFile; fileRef = 61F040F11448547000A0C788 /* FileMD5Hash.c */; };
 		61F04132144DB97200A0C788 /* PithosLocalObjectState.m in Sources */ = {isa = PBXBuildFile; fileRef = 61F040EE144757B500A0C788 /* PithosLocalObjectState.m */; };
 		61F04133144DB97600A0C788 /* PithosSyncDaemon.m in Sources */ = {isa = PBXBuildFile; fileRef = 61F040EA144724F500A0C788 /* PithosSyncDaemon.m */; };
-		E26038A7150009E400DAC6EB /* InspectorPane.m in Sources */ = {isa = PBXBuildFile; fileRef = E260389C150009E400DAC6EB /* InspectorPane.m */; };
-		E26038A8150009E400DAC6EB /* InspectorPaneBody.m in Sources */ = {isa = PBXBuildFile; fileRef = E260389E150009E400DAC6EB /* InspectorPaneBody.m */; };
-		E26038A9150009E400DAC6EB /* InspectorPaneContainer.m in Sources */ = {isa = PBXBuildFile; fileRef = E26038A0150009E400DAC6EB /* InspectorPaneContainer.m */; };
-		E26038AA150009E400DAC6EB /* InspectorPaneHead.m in Sources */ = {isa = PBXBuildFile; fileRef = E26038A2150009E400DAC6EB /* InspectorPaneHead.m */; };
-		E26038AB150009E400DAC6EB /* NSBezierPath+StrokeExtensions.m in Sources */ = {isa = PBXBuildFile; fileRef = E26038A4150009E400DAC6EB /* NSBezierPath+StrokeExtensions.m */; };
-		E26038AC150009E400DAC6EB /* NSWindow+Geometry.m in Sources */ = {isa = PBXBuildFile; fileRef = E26038A6150009E400DAC6EB /* NSWindow+Geometry.m */; };
+		E26038A7150009E400DAC6EB /* InspectorPane.m in Sources */ = {isa = PBXBuildFile; fileRef = E260389C150009E400DAC6EB /* InspectorPane.m */; settings = {COMPILER_FLAGS = "-fno-objc-arc"; }; };
+		E26038A8150009E400DAC6EB /* InspectorPaneBody.m in Sources */ = {isa = PBXBuildFile; fileRef = E260389E150009E400DAC6EB /* InspectorPaneBody.m */; settings = {COMPILER_FLAGS = "-fno-objc-arc"; }; };
+		E26038A9150009E400DAC6EB /* InspectorPaneContainer.m in Sources */ = {isa = PBXBuildFile; fileRef = E26038A0150009E400DAC6EB /* InspectorPaneContainer.m */; settings = {COMPILER_FLAGS = "-fno-objc-arc"; }; };
+		E26038AA150009E400DAC6EB /* InspectorPaneHead.m in Sources */ = {isa = PBXBuildFile; fileRef = E26038A2150009E400DAC6EB /* InspectorPaneHead.m */; settings = {COMPILER_FLAGS = "-fno-objc-arc"; }; };
+		E26038AB150009E400DAC6EB /* NSBezierPath+StrokeExtensions.m in Sources */ = {isa = PBXBuildFile; fileRef = E26038A4150009E400DAC6EB /* NSBezierPath+StrokeExtensions.m */; settings = {COMPILER_FLAGS = "-fno-objc-arc"; }; };
+		E26038AC150009E400DAC6EB /* NSWindow+Geometry.m in Sources */ = {isa = PBXBuildFile; fileRef = E26038A6150009E400DAC6EB /* NSWindow+Geometry.m */; settings = {COMPILER_FLAGS = "-fno-objc-arc"; }; };
 		E26038B215000C4B00DAC6EB /* QuartzCore.framework in Frameworks */ = {isa = PBXBuildFile; fileRef = E26038B115000C4B00DAC6EB /* QuartzCore.framework */; };
 /* End PBXBuildFile section */
 
@@ -782,6 +782,8 @@
 			isa = XCBuildConfiguration;
 			buildSettings = {
 				ALWAYS_SEARCH_USER_PATHS = NO;
+				ARCHS = "$(ARCHS_STANDARD_64_BIT)";
+				CLANG_ENABLE_OBJC_ARC = YES;
 				COMBINE_HIDPI_IMAGES = YES;
 				COPY_PHASE_STRIP = NO;
 				GCC_DYNAMIC_NO_PIC = NO;
@@ -789,6 +791,7 @@
 				GCC_PRECOMPILE_PREFIX_HEADER = YES;
 				GCC_PREFIX_HEADER = "pithos-macos/pithos-macos-Prefix.pch";
 				INFOPLIST_FILE = "pithos-macos/pithos-macos-Info.plist";
+				MACOSX_DEPLOYMENT_TARGET = 10.6.8;
 				PRODUCT_NAME = "$(TARGET_NAME)";
 				WRAPPER_EXTENSION = app;
 			};
@@ -798,6 +801,8 @@
 			isa = XCBuildConfiguration;
 			buildSettings = {
 				ALWAYS_SEARCH_USER_PATHS = NO;
+				ARCHS = "$(ARCHS_STANDARD_64_BIT)";
+				CLANG_ENABLE_OBJC_ARC = YES;
 				COMBINE_HIDPI_IMAGES = YES;
 				COPY_PHASE_STRIP = YES;
 				DEBUG_INFORMATION_FORMAT = "dwarf-with-dsym";
@@ -805,6 +810,7 @@
 				GCC_PRECOMPILE_PREFIX_HEADER = YES;
 				GCC_PREFIX_HEADER = "pithos-macos/pithos-macos-Prefix.pch";
 				INFOPLIST_FILE = "pithos-macos/pithos-macos-Info.plist";
+				MACOSX_DEPLOYMENT_TARGET = 10.6.8;
 				PRODUCT_NAME = "$(TARGET_NAME)";
 				WRAPPER_EXTENSION = app;
 			};